/*

Copyright 2011 Giuseppe Cosentino Borgese <gicos.2@gmail.com>

This file is part of gSudoku.

gSudoku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

gSudoku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gSudoku.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef SUDOKUTABLE_H_
#define SUDOKUTABLE_H_
#include <list>
#include <cstdlib>
#include <cassert>
#include <iostream>
#include "SudokuCell.h"

using namespace std;

class SudokuTable {
private:
	SudokuCell sTable[9][9];

public:
	SudokuTable();
	bool loadSudoku(string);
	bool solveTable(int, int);
	void resetTable();
	void printTable();
	list<int> validValues(int, int);
	int getCellValue(int, int);
	void setCellValue(int, int, int);
	bool isCellFixed(int, int);
};

#endif /* SUDOKUTABLE_H_ */
