/*

Copyright 2011 Giuseppe Cosentino Borgese <gicos.2@gmail.com>

This file is part of gSudoku.

gSudoku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

gSudoku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gSudoku.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "GUIError.h"

GUIError::GUIError(WINDOW *mW, int sX, int sY, bool ok):
	onlyOK(ok)
{
	mainWin = mW;
	errorWin = subwin(mainWin, 5, 27, sY, sX);
}

bool GUIError::showError(string errTxt){
	box(errorWin, 0, 0);

	mvwaddstr(errorWin, 1, 1, &errTxt[0]);
	mvwaddstr(errorWin, 2, 1, "-------------------------");
	if(onlyOK){
		wcolor_set(errorWin, 2, NULL);
		mvwaddstr(errorWin, 3, 1, "          Chiudi         ");
		wcolor_set(errorWin, 1, NULL);
		wrefresh(errorWin);
		while(true){
			int ch = getch();
			if(ch == '\n'){
				return true;
			}
		}
	}else{
		int sErr = false;
		mvwaddstr(errorWin, 3, 1, "            |            ");
		while(true){
			wcolor_set(errorWin, (sErr) ? 2 : 1, NULL);
			mvwaddstr(errorWin, 3, 1, "     Si     ");
			wcolor_set(errorWin, (sErr) ? 1 : 2, NULL);
			mvwaddstr(errorWin, 3, 14, "     No     ");
			wcolor_set(errorWin, 1, NULL);
			wrefresh(errorWin);
			int ch = getch();
			switch(ch){
			case KEY_LEFT:
			case KEY_RIGHT:
				sErr = !sErr;
				break;
			case '\n':
				return sErr;
			}
		}
	}
	return true;
}

GUIError::~GUIError(){
	for(int i = 0; i < 5; i++){
		mvwaddstr(errorWin, i, 0, "                           ");
	}
	delwin(errorWin);
	refresh();
}
