/*

Copyright 2011 Giuseppe Cosentino Borgese <gicos.2@gmail.com>

This file is part of gSudoku.

gSudoku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

gSudoku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gSudoku.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include "GUIMain.h"

GUIMain::GUIMain(WINDOW *mW, int mY, int mX) :
mainWin(mW), maxY(mY), maxX(mX)
{
	menuItems.push_back("Nuova partita");
	menuItems.push_back("[");
	menuItems.push_back("Informazioni");
	menuItems.push_back("Esci dal gioco");
	sMax = menuItems.size();
	wHei = (2 * sMax) + 1;
	wWid = 25;
	sX = (maxX - wWid) / 2;
	sY = ((maxY - wHei) / 2) + 2;

	menuWin = subwin(mainWin, wHei, wWid, sY, sX);
}

int GUIMain::mainMenu(){
	int pKey, sMenu = 0, nLvl = 0;
	string toPrint, sLvl;

	box(menuWin, 0 , 0);
	while(true){
		for(int i = 0; i < (wHei - 2); i++){
			if(i % 2 == 0){
				int k = i / 2;
				if(k == sMenu){
					wcolor_set(menuWin, 2, NULL);
				}
				mvwaddstr(menuWin, (i + 1), 1, "                       ");
				switch(menuItems[k][0]){
				case '[':
					switch(nLvl){
					case 0:
						sLvl = "Facile";
						break;
					case 1:
						sLvl = "Medio";
						break;
					case 2:
						sLvl = "Difficile";
						break;
					}
					toPrint = "Livello: ";
					toPrint.append(sLvl);
					break;
				default:
					toPrint = menuItems[k];
					break;
				}
				mvwaddstr(menuWin, (i + 1), 3, &toPrint[0]);
			}else{
				mvwaddstr(menuWin, (i + 1), 1, "-----------------------");
			}
			wcolor_set(menuWin, 1, NULL);
		}
		wrefresh(menuWin);
		pKey = getch();
		switch(pKey){
		case KEY_UP:
			sMenu = ((sMenu - 1) < 0) ? (sMax - 1) : (sMenu - 1);
			break;
		case KEY_DOWN:
			sMenu = (sMenu + 1) % sMax;
			break;
		case '\n':
			switch(sMenu){
			case 0:
				return 10 + nLvl;
				break;
			case 1:
				nLvl = (nLvl + 1) % 3;
				break;
			case 2:
				return 80;
				break;
			case 3:
				return 90;
				break;
			}
			break;
		}
	}
}

GUIMain::~GUIMain(){
	delwin(menuWin);
	refresh();
}
