/*

Copyright 2011 Giuseppe Cosentino Borgese <gicos.2@gmail.com>

This file is part of gSudoku.

gSudoku is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

gSudoku is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gSudoku.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GUISUDOKU_H_
#define GUISUDOKU_H_
#include <string>
#include <vector>
#include "curses.h"
#include "../Backend/SudokuTable.h"
#include "../Backend/SudokuDB.h"

using namespace std;

class GUISudoku {
private:
	WINDOW *mainWin, *sudokuWin, *optionsWin, *hintsWin;
	int maxX, maxY, sMax;
	int wWid, wHei;
	int errPosX, errPosY;
	vector<string> menuItems;
	bool checkErrors, showHints;

	SudokuTable sdUser, sdSolved, sdUnsolved;
	int selX, selY;

	void drawOptionsWin(int);
	void drawSudokuWin();
	void drawHintsWin();
	void useOptionsWin();
	void useSudokuWin();
public:
	GUISudoku(WINDOW *, int, int, int);
	void playSudoku();
	~GUISudoku();
};

#endif /* GUISUDOKU_H_ */
